#pragma once
//-------------------------------------------------------------------
// Fݒ\{^
//-------------------------------------------------------------------
class CColorSettingButton : public CWindowImpl<CColorSettingButton>
{
protected:
	BOOL     m_blnPushedByKey;
	BOOL	 m_blnOnFocus;
	BOOL     m_blnPushed;							//
	COLORREF m_lngColor;							//F
public:
    BEGIN_MSG_MAP_EX(CColorSettingButton)
        MSG_WM_LBUTTONDOWN(OnLButtonDown)
        MSG_WM_LBUTTONUP (OnLButtonUp)
        MSG_WM_PAINT     (OnPaint)
		MSG_WM_SETFOCUS  (OnSetFocus)
		MSG_WM_KILLFOCUS (OnKillFocus)
		MSG_WM_KEYDOWN   (OnKeyDown)
		MSG_WM_KEYUP     (OnKeyUp)
    END_MSG_MAP()

	// TuNX
	void Attach (HWND hWnd , COLORREF lngColor)
	{
		SubclassWindow (hWnd);
		m_lngColor  = lngColor;
		m_blnOnFocus = FALSE;
		m_blnPushed = FALSE;
		return ;
	}
	// tH[JX擾
	void OnSetFocus (HWND hWnd)
	{
		m_blnOnFocus = TRUE;
		Invalidate();
		UpdateWindow();
	}
	// tH[JXr
	void OnKillFocus (HWND hWnd)
	{
		m_blnOnFocus = FALSE;
		Invalidate();
		UpdateWindow();
	}
	// L[
	void OnKeyDown (TCHAR nChar, UINT nRepCount , UINT nFlags )
	{
		if (m_blnPushed) {
			return;
		}
		if (nChar == VK_SPACE) {
			m_blnPushedByKey = TRUE;
			m_blnPushed = TRUE;
			Invalidate();
			UpdateWindow();
		}
	}
	// L[
	void OnKeyUp   (TCHAR nChar, UINT nRepCount , UINT nFlags )
	{
		if (m_blnPushed && m_blnPushedByKey) {				//
			CallColorDialog();
			m_blnPushed = FALSE;
			m_blnPushedByKey = FALSE;
			Invalidate();
			UpdateWindow();
		}
	}
	// {^_E
    void OnLButtonDown(UINT uFlags, CPoint pt)
	{
		if (m_blnPushed) {
			return;
		}
		m_blnPushedByKey = FALSE;
		SetCapture();
		SetMsgHandled(FALSE);
		m_blnPushed = TRUE;
		Invalidate();
		UpdateWindow();
    }
	// {^Abv
    void OnLButtonUp(UINT uFlags, CPoint pt)
	{
		CRect clsRect;
		if (::GetCapture() == m_hWnd ) {			//?gMouseDown
			if ( m_blnPushed ) {
				m_blnPushed = FALSE;
				GetClientRect( &clsRect );
				if (clsRect.PtInRect ( pt ) ) {			//?[X_{^̒
					CallColorDialog();
				}
				Invalidate();
				UpdateWindow();
			}
			ReleaseCapture();
		}
        SetMsgHandled(FALSE);
    }
	// `
	void OnPaint(HDC hdc) 
	{
		CPaintDC clsDC ( *this );
		CRect clsRect;
		CBrush clsBrush;
		GetClientRect( &clsRect );
		clsBrush.CreateSolidBrush ( m_lngColor );
		if (m_blnOnFocus) {								//?tH[JX擾
			clsDC.FrameRect ( clsRect , (HBRUSH)GetStockObject ( BLACK_BRUSH ) );
			clsRect.DeflateRect ( 1 , 1 );
		}
		clsDC.DrawEdge ( clsRect , (m_blnPushed ? EDGE_SUNKEN : EDGE_RAISED ), BF_ADJUST | BF_RECT );
		clsDC.FillRect ( clsRect , clsBrush );
		return;
	}
	//  Color_CAO\
	void CallColorDialog()
	{
//		::SendMessage(GetParent(), WM_COMMAND, MAKEWPARAM(GetDlgCtrlID(), BN_CLICKED), (LPARAM)m_hWnd);
		CColorDialog dlgColor ( m_lngColor );
		if (dlgColor.DoModal () == IDOK ) {
			m_lngColor = dlgColor.GetColor();
		}
	}
	// Fԋp
	COLORREF GetColor()
	{
		return m_lngColor;
	}
};
//-------------------------------------------------------------------
// ̓GfBg{bNX
//-------------------------------------------------------------------
class CXEditNumeric : public CWindowImpl<CXEditNumeric>
{
protected:
	int				m_intDigitCount;					//̓TCY
	CComCurrency	m_curMin;							//ŏl
	CComCurrency	m_curMax;							//ől
public:
    BEGIN_MSG_MAP_EX(CXEditNumeric)
		MSG_WM_CHAR ( OnChar )
    END_MSG_MAP()
private:
	//
	// tH[}bg擾
	//
	void Format ( CString &strDisplay , const CComCurrency curValue , const int intIntegerSize , const int intFrationSize )
	{
		int intFraction;
		LONGLONG lngInteger;

		intFraction = curValue.GetFraction();
		lngInteger =  curValue.GetInteger();
		strDisplay.Empty();
		strDisplay.AppendFormat ( _T("%*ld") , intIntegerSize , lngInteger );
		strDisplay += _T(".");

		CString strFraction;
		strFraction.Format(_T("%04d"),abs(intFraction));
		strDisplay += strFraction.Left(intFrationSize);
	}
public:
	// TuNX
	void Attach (HWND hWnd , CComCurrency &curValue ,int intIntegerSize , int intFrationSize ,CComCurrency &curMax ,CComCurrency &curMin)
	{
		m_curMax   = curMax;
		m_curMin   = curMin;
		SubclassWindow (hWnd);
		SendMessage ( hWnd , EM_SETLIMITTEXT , intIntegerSize + intFrationSize + 1 , 0 );
		CString strValue;
		if ( curValue == (CComCurrency)0L ) {											//?0ȂNA
			SetWindowText ( _T("") );
		}
		else {															//?0ȊOȂlݒ
			Format ( strValue , curValue , intIntegerSize , intFrationSize );
			SetWindowText ( (LPCTSTR)strValue );
		}
	}
	void OnChar(TCHAR vkey, UINT repeats, UINT code)
	{
		if (vkey >= '0' && vkey <= '9') {
			SetMsgHandled(FALSE);
		}
		else if ( vkey == '.' || vkey == VK_BACK )  {
			SetMsgHandled(FALSE);
		}
		else {
			ATLTRACE (_T("%02X,%d,%04X\n"),vkey ,repeats,code);
		}
	}
	BOOL IsValidValue()
	{
		CComCurrency curValue;
		GetValue ( curValue );
		return ( ( curValue >= m_curMin ) && ( curValue <= m_curMax ));
	}
	void GetValue ( CComCurrency &curValue )
	{
		CString strValue;
		GetWindowText ( strValue );
		if ( strValue.Trim().GetLength () == 0 ) {				//?0
			curValue = (CComCurrency)0L;
		}
		else {
			curValue = (CComCurrency)strValue;
		}
	}
};


